/* File : libhnj.i */
%module hnj
%{
#include <hyphenate.h>
%}

#include <hyphenate.h>


/* convert returned char * to a perl string and free it 
   the hackish bit with argvi shouldn't be necessary;
   normally it should just use $target, but that didn't work */

%typemap (perl5, out) char *hyphenate_line 
{
   if ($source) 
   {
      ST(argvi) = sv_newmortal();
      sv_setpv((SV*) ST(argvi++), (char *)$source);
      /* printf("Received a char : %s\n", $source); */
      hnj_free ($source);
   } 
   else { $target = &sv_undef; }
}

HyphenDict *hnj_hyphen_load (const char *fn);
HyphenDict *hnj_hyphen_load_locale (const char *locale);
HyphenDict *hnj_hyphen_load_locale_default ();

void hnj_hyphen_free (HyphenDict *dict);
void hnj_hyphen_hyphenate (HyphenDict *dict,
                           const char *word, int word_size,
                           char *hyphens);
void hnj_hyphen_hyphenate_line (HyphenDict *dict,
                                const char *line, int line_size,
                                char *hyphens);

%inline %{
char *hyphenate_line (HyphenDict *dict, const char *line)
{
  int len = strlen (line);
  int i;
  char *hyphens;

  hyphens = (char *) hnj_malloc (len + 1);
  for (i = 0; i < len; ++i) hyphens[i] = 0;

  hnj_hyphen_hyphenate_line (dict, line, len, hyphens);
  hyphens[len] = 0;
  return hyphens;
}
%}
